<?php
/**
* @version		$Id: mod_quickicon.php 14401 2010-01-26 14:10:00Z louis $
* @package		Joomla
* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

if (!defined( '_JOS_QUICKICON_MODULE' ))
{
	/** ensure that functions are declared only once */
	define( '_JOS_QUICKICON_MODULE', 1 );

	function quickiconButton( $link, $image, $text )
	{
		global $mainframe;
		$db 		= JFactory::getDBO();
		$lang		=& JFactory::getLanguage();
		$template	= $mainframe->getTemplate();
		?>
		<div style="float:<?php echo ($lang->isRTL()) ? 'right' : 'left'; ?>;">
			<div class="icon">
				<a href="<?php echo $link; ?>">
					<?php echo JHTML::_('image.site',  $image, '/templates/'. $template .'/images/header/', NULL, NULL, $text ); ?>
					<span><?php echo $text; ?></span></a>
			</div>
		</div>
		<?php
	}
	
	function checklatestJoomlaversion($option){
		global $mainframe;
		$db = JFactory::getDBO();
		$db->setQuery("Select * from #__ud_config");
		$config = $db->loadObjectList();
		$server_link = $config[1]->config_value;
		$check_version_link = $server_link."/index2.php?option=com_upgrademanage&task=check_version";
		if(function_exists('curl_exec'))
		{
			$ch = curl_init($check_version_link);
	        curl_setopt($ch, CURLOPT_HEADER, 0);
	        curl_setopt($ch, CURLOPT_POST, 1);
	        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	        $data = curl_exec($ch);      
	        curl_close($ch);
			if($data){
				$dataArr = explode("@",$data);
				$version = $dataArr[1];
				//update into db
				$db->setQuery("Update #__ud_version set latest_version = '$version',update_on = '".time()."'");
				$db->query();
			}
		}else{
			$data = file_get_contents($check_version_link);
			if($data){
				$dataArr = explode("@",$data);
				$version = $dataArr[1];
				//update into db
				$db->setQuery("Update #__ud_version set latest_version = '$version',update_on = '".time()."'");
				$db->query();
			}
		}
	}

	// define language
	$language = Jfactory::getLanguage();
	$meta_language = $language->_metadata;
	$lang = $meta_language['tag'];
	if($lang == ""){
		$lang = "en-GB";
	} 
	if(!file_exists(JPATH_ADMINISTRATOR.DS."components".DS."com_jupdate".DS."languages".DS.$lang.".php")){
		include(JPATH_ADMINISTRATOR.DS."components".DS."com_jupdate".DS."languages".DS."en-GB.php");	
	}else{
		include(JPATH_ADMINISTRATOR.DS."components".DS."com_jupdate".DS."languages".DS.$lang.".php");
	}
	
	?>
	<div id="cpanel">
		<?php
		$link = 'index.php?option=com_content&amp;task=add';
		quickiconButton( $link, 'icon-48-article-add.png', JText::_( 'Add New Article' ) );

		$link = 'index.php?option=com_content';
		quickiconButton( $link, 'icon-48-article.png', JText::_( 'Article Manager' ) );

		$link = 'index.php?option=com_frontpage';
		quickiconButton( $link, 'icon-48-frontpage.png', JText::_( 'Frontpage Manager' ) );

		$link = 'index.php?option=com_sections&amp;scope=content';
		quickiconButton( $link, 'icon-48-section.png', JText::_( 'Section Manager' ) );

		$link = 'index.php?option=com_categories&amp;section=com_content';
		quickiconButton( $link, 'icon-48-category.png', JText::_( 'Category Manager' ) );

		$link = 'index.php?option=com_media';
		quickiconButton( $link, 'icon-48-media.png', JText::_( 'Media Manager' ) );

		// Get the current JUser object
		$user = &JFactory::getUser();

		if ( $user->get('gid') > 23 ) {
			$link = 'index.php?option=com_menus';
			quickiconButton( $link, 'icon-48-menumgr.png', JText::_( 'Menu Manager' ) );
		}

		if ( $user->get('gid') > 24 ) {
			$link = 'index.php?option=com_languages&amp;client=0';
			quickiconButton( $link, 'icon-48-language.png', JText::_( 'Language Manager' ) );
		}

		if ( $user->get('gid') > 23 ) {
			$link = 'index.php?option=com_users';
			quickiconButton( $link, 'icon-48-user.png', JText::_( 'User Manager' ) );
		}

		if ( $user->get('gid') > 24 ) {
			$link = 'index.php?option=com_config';
			quickiconButton( $link, 'icon-48-config.png', JText::_( 'Global Configuration' ) );
		}
		$db = JFactory::getDBO();
		$currenttime    = time();
		$db->setQuery("Select * from #__ud_version");
		$rows = $db->loadObjectList();
		$row = $rows[0];
		$update_on =  $row->update_on;
		if($currenttime - $update_on > 3600*24){
			$latestversion  = checklatestJoomlaversion($option);
			$db->setQuery("Update #__ud_version set current_version = '$currentversion' ,latest_version = '$latestversion', update_on = '$currenttime'");
			$db->query();
		}
		$db->setQuery("Select * from #__ud_version");
		$row = $db->loadObject();
		if($row->current_version == $row->latest_version){
			$link = 'index.php?option=com_jupdate';
			quickiconButton( $link, 'icon-48-checkin.png', _JOOMLA_UPTODATE);
		}else{
			$link = 'index.php?option=com_jupdate';
			quickiconButton( $link, 'icon-48-info.png', _JOOMLA_UPDATE );
		}
		?>
	</div>
	<?php
}