<?php
/**
* @version		$Id: admin.contact.php 10571 2008-07-21 01:27:35Z pasamio $
* @package		Joomla
* @subpackage	Credit Backend
* @copyright	Copyright (C) 2005 - 2008 Ossolution. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/

defined( '_JEXEC' ) or die( 'Restricted access' );
error_reporting(E_PARSE | E_CORE_ERROR | E_COMPILE_ERROR | E_ERROR | E_USER_ERROR | E_RECOVERABLE_ERROR);
include(JPATH_COMPONENT.DS."jupdate.html.php");

include(JPATH_COMPONENT_ADMINISTRATOR.DS."helpers".DS."ftp.php");

jimport('joomla.utilities.date');

// define language
$language = Jfactory::getLanguage();
$meta_language = $language->_metadata;
$lang = $meta_language['tag'];
if($lang == ""){
	$lang = "en-GB";
} 
if(!file_exists(JPATH_COMPONENT_ADMINISTRATOR.DS."languages".DS.$lang.".php")){
	include(JPATH_COMPONENT_ADMINISTRATOR.DS."languages".DS."en-GB.php");	
}else{
	include(JPATH_COMPONENT_ADMINISTRATOR.DS."languages".DS."$lang.php");
}

$task = JRequest::getVar('task','');

switch ($task){
	case "doinstall":
		doinstall($option);
	break;
	case "dobackup":
		restore($option);
	break;
}

function restore($option){
	global $mainframe;
	$db = JFactory::getDBO();
	//create temp folder
	jimport('joomla.filesystem.folder');
	jimport('joomla.filesystem.archive');
	jimport('joomla.filesystem.file');
	
	$backup_folder = JPATH_ROOT.DS."tmp".DS."backup";
	$arr = JFolder::listFolderTree($backup_folder);
	for($i=0;$i<count($arr);$i++){
		$foldername =  $arr[$i]['fullname'];
		$files = JFolder::files($foldername);
		$folder_insite = str_replace("tmp".DS."backup".DS,"",$foldername);
		for($j=0;$j<count($files);$j++){
			$file = $files[$j];
			JFile::copy($foldername.DS.$file,$folder_insite.DS.$file);
		}
	}
	//for the file in the root folder
	$files = JFolder::files($backup_folder);
	$folder_insite = JPATH_ROOT;
	for($j=0;$j<count($files);$j++){
		$file = $files[$j];
		JFile::copy($backup_folder.DS.$file,$folder_insite.DS.$file);
	}
	
	$db->setQuery("Select * from #__ud_backup");
	$backup = $db->loadObject();
	$version = $backup->version;
	$db->setQuery("Update #__ud_version set current_version = '$version'");
	$db->query();
	
	HTML_joomlaupdate::restoreComplete($option);
}


function doinstall($option){
	global $mainframe;
	$db = JFactory::getDBO();
	$db->setQuery("Select * from #__ud_version");
	$old_version = $db->loadObject();
	//in the case cannot check current version
	if($old_version->current_version == ""){
		$jv = new JVersion();
		$current_version = $jv->getShortVersion();
		$db->setQuery("Update #__ud_version set current_version = '$current_version'");
		$db->query();
	}
	if($old_version->latest_version == ""){
		$latest_version = checklatestJoomlaversion($option);
		if($latest_version == ""){
			$latest_version = secondattempcheckJoomlaVersion($option);
		}
		$db->setQuery("Update #__ud_version set latest_version = '$latest_version'");
		$db->query();
	}
	$db->setQuery("Select * from #__ud_version");
	$old_version = $db->loadObject();
	
	
	$temp_folder = "backup_".time();
	$filename = JRequest::getVar('file','');
	$filename = base64_decode($filename);
	
	$tempdir = JRequest::getVar('tempdir','');
	$root = JPATH_ROOT;
	$backup = JRequest::getVar('backup',0);
	if($backup == 1){
		//do backup
		$backup_rs = dobackup($filename,$temp_folder);
	}else{
		//remove from table
		$backup_folder = JPATH_ROOT.DS."tmp".DS."backup";
		if(is_dir($backup)){
			if(!rmdir($backup_folder)){
				$conn_id = joomlaUpdateHelperFtp::initftp();
				if($conn_id){
					$db->setQuery("Select config_value from #__ud_config where id = '13'");
					$ftp_root = $db->loadResult();
					$backup_folder = str_replace(JPATH_ROOT,$ftp_root,$backup_folder);
					ftp_rmdir($conn_id,$backup_folder);
				}
			}
		}
		$db->setQuery("Delete from #__ud_backup");
		$db->query();
	}
	
	jimport('joomla.filesystem.archive');
	$chmod = chmod($filename,0755);
	if(!$chmod){
		if(joomlaUpdateHelperFtp::initftp()){
			$chmod = joomlaUpdateHelperFtp::changemode($filename,0775);
		}
	}
	if(!$chmod){
		echo _CANNOT_CHANGE_FILE_PERMISSION;
	}else{
		if(JArchive::extract($filename, $root)){
			$db->setQuery("Select count(id) from #__ud_backup");
			$isbackup = $db->loadResult();
			//update into version table
			$db->setQuery("Update #__ud_version set current_version = '$old_version->latest_version'");
			$db->query();
			
			HTML_joomlaupdate::installComplete($option,$old_version,$isbackup);
		}else{
			if(!joomlaUpdateHelperFtp::extractzip($filename)){
				echo _CANNOT_EXTRACT_ZIP_FILE;
			}else{
				$db->setQuery("Select count(id) from #__ud_backup");
				$isbackup = $db->loadResult();
				//update into version table
				$db->setQuery("Update #__ud_version set current_version = '$old_version->latest_version'");
				$db->query();
				
				HTML_joomlaupdate::installComplete($option,$old_version,$isbackup);
			}
		}
	}
}

function dobackup($link,$folder){
	global $mainframe;
	$db = JFactory::getDBO();
	//create temp folder
	jimport('joomla.filesystem.folder');
	jimport('joomla.filesystem.archive');
	jimport('joomla.filesystem.file');
	
	$temp_folder = JPATH_ROOT.DS."tmp".DS.$folder;
	$backup_folder = JPATH_ROOT.DS."tmp".DS."backup";
	
	
	//remove backup folder
	if(is_dir($backup_folder)){
		if(!JFolder::delete($backup_folder)){
			if($conn_id){
				$db->setQuery("Select config_value from #__ud_config where id = '13'");
				$ftp_root = $db->loadResult();
				$backup_folder_tmp = str_replace(JPATH_ROOT,$ftp_root,$backup_folder);
				ftp_rmdir($conn_id,$backup_folder_tmp);
			}
			ftp_close($conn_id);
		}
	}
	
	$db->setQuery("Delete from #__ud_backup");
	$db->query();
	//create the backup folder
	JFolder::create($backup_folder);
	//damdt
	
	JFolder::create($temp_folder);
	
	$chmod = chmod($link,0755);
	if(!$chmod){
		$conn_id = $conn_id = joomlaUpdateHelperFtp::initftp();
		if($conn_id){
			$chmod = joomlaUpdateHelperFtp::changemode($link,0775);
		}
		ftp_close($conn_id);
	}
	if(!$chmod){
		echo _CANNOT_CREATE_BACKUP_FILE."&nbsp;&nbsp;<BR>";
	}else{
		JArchive::extract($link,$temp_folder);
		$arr = JFolder::listFolderTree($temp_folder);
		for($i=0;$i<count($arr);$i++){
			$foldername =  $arr[$i]['fullname'];
			$foldername_new = str_replace($folder,"backup",$foldername);
			JFolder::create($foldername_new);
			$files = JFolder::files($foldername);
			$folder_insite = str_replace("tmp".DS.$folder.DS,"",$foldername);
			for($j=0;$j<count($files);$j++){
				$file = $files[$j];
				JFile::copy($folder_insite.DS.$file,$foldername_new.DS.$file);
			}
		}
		//for the file in the root folder
		$files = JFolder::files($temp_folder);
		$folder_insite = JPATH_ROOT;
		for($j=0;$j<count($files);$j++){
			$file = $files[$j];
			JFile::copy($folder_insite.DS.$file,$backup_folder.DS.$file);
		}
		
		//save into backup
		//$db->setQuery("Select current_version from #__ud_version");
		//$current_version = $db->loadResult();
		$jv = new JVersion();
		$current_version = $jv->getShortVersion();
		$db->setQuery("Insert into #__ud_backup (id,backup,version) values (NULL,'".time()."','$current_version')");
		$db->query();
	}
}

function checklatestJoomlaversion($option){
	global $mainframe;
	$db = JFactory::getDBO();
	$db->setQuery("Select * from #__ud_config");
	$config = $db->loadObjectList();
	$server_link = $config[1]->config_value;
	$check_version_link = $server_link."/index2.php?option=com_upgrademanage&task=check_version";
	if(function_exists('curl_exec'))
	{
		$ch = curl_init();
		if (! $ch){
			$data = file_get_contents($check_version_link);
			if($data){
				$dataArr = explode("@",$data);
				$version = $dataArr[1];
				//update into db
				$db->setQuery("Update #__ud_version set latest_version = '$version',update_on = '".time()."'");
				$db->query();
			}
		}else{
			curl_setopt($ch, CURLOPT_URL,$check_version_link );
	        curl_setopt($ch, CURLOPT_HEADER, 0);
			curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
	        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_TIMEOUT,        30);
	        $data = curl_exec($ch);   
	        curl_close($ch);
			if($data){
				$dataArr = explode("@",$data);
				$version = $dataArr[1];
				//update into db
				$db->setQuery("Update #__ud_version set latest_version = '$version',update_on = '".time()."'");
				$db->query();
			}
		}
	}else{
		$data = file_get_contents($check_version_link);
		if($data){
			$dataArr = explode("@",$data);
			$version = $dataArr[1];
			//update into db
			$db->setQuery("Update #__ud_version set latest_version = '$version',update_on = '".time()."'");
			$db->query();
		}
	}
}


function secondattempcheckJoomlaVersion($option){
	global $mainframe;
	$db = JFactory::getDBO();
	$db->setQuery("Select * from #__ud_config");
	$config = $db->loadObjectList();
	$check_version_link = "http://jsitepoint.com/update/packages/joomla/update.xml";
	if(function_exists('curl_exec'))
	{
		$ch = curl_init();
		if (! $ch){
			$data = file_get_contents($check_version_link);
			if($data){
				$version = loadValuefromXml($data);
			}
		}else{
			curl_setopt($ch, CURLOPT_URL,$check_version_link );
	        curl_setopt($ch, CURLOPT_HEADER, 0);
			curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
	        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_TIMEOUT,        30);
	        $data = curl_exec($ch);   
	        curl_close($ch);
	        if($data){
				$version = loadValuefromXml($data);
			}
		}
	}else{
		$data = file_get_contents($check_version_link);
		if($data){
			$version = loadValuefromXml($data);
		}
	}
	
	if($version != ""){
		$db->setQuery("Update #__ud_version set latest_version = '$version',update_on = '".time()."'");
		$db->query();
	}
	return $version;
}

function loadValuefromXml($result){
	require_once( JPATH_SITE . DS."libraries".DS."domit".DS."xml_domit_lite_include.php" );
	$xmlDoc = new DOMIT_Lite_Document();
	$xmlDoc->resolveErrors( true );
	$xmlDoc->parseXML($result,false,true);
	$root=&$xmlDoc->documentElement;
	$release = $root->getAttribute('release');
	$release = trim($release);
	return $release;
}
?>